



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>POJ - 3037 Skiing SPFA</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">POJ - 3037 Skiing SPFA</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-11 16:02:57 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<h2>Skiing</h2>
</div>
<div>Bessie and the rest of Farmer John's cows are taking a trip this winter to go skiing. One day Bessie finds herself at the top left corner of an R (1 &lt;= R &lt;= 100) by C (1 &lt;= C &lt;= 100) grid of elevations E (-25 &lt;= E &lt;= 25). In order to join FJ and the other cows at a discow party, she must get down to the bottom right corner as quickly as she can by travelling only north, south, east, and west.</p>
<p>Bessie starts out travelling at a initial speed V (1 &lt;= V &lt;= 1,000,000). She has discovered a remarkable relationship between her speed and her elevation change. When Bessie moves from a location of height A to an adjacent location of eight B, her speed is multiplied by the number 2^(A-B). The time it takes Bessie to travel from a location to an adjacent location is the reciprocal of her speed when she is at the first location.</p>
<p>Find the both smallest amount of time it will take Bessie to join her cow friends.</p></div>
<p>Input</p>
<div>* Line 1: Three space-separated integers: V, R, and C, which respectively represent Bessie's initial velocity and the number of rows and columns in the grid.</p>
<p>* Lines 2..R+1: C integers representing the elevation E of the corresponding location on the grid.</p></div>
<p>Output</p>
<div>A single number value, printed to two exactly decimal places: the minimum amount of time that Bessie can take to reach the bottom right corner of the grid.</div>
<p>Sample Input</p>
<pre class="prettyprint linenums">1 3 3<br />
1 5 3<br />
6 3 5<br />
2 4 3</pre>
<p>Sample Output</p>
<pre class="prettyprint linenums">29.00</pre>
<p>Hint</p>
<div>Bessie's best route is:&nbsp;<br />Start at 1,1 time 0 speed 1&nbsp;<br />East to 1,2 time 1 speed 1/16&nbsp;<br />South to 2,2 time 17 speed 1/4&nbsp;<br />South to 3,2 time 21 speed 1/8&nbsp;<br />East to 3,3 time 29 speed 1/4</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>题意：以邻接矩阵形式读入各点高度，滑到某点速度为v0*2^(原点高度-某点高度)，求从左上滑到右下用时。</div>
<div>思路：SPFA。1.0/v即为上一点到当前点用时，扩展到右下点找出最短用时。注意到某点用时一定要提前记录，如果在扩展时现求的话会有许多重复计算，导致TLE。。（pow(,)的计算相当耗时）</div>
<div>ps：SPFA O(kE)，k小于等于2（已证明）E为边数，适合稀疏图（可含负边），加优化Dij O((n+m)logn)适合稠密图。在练习最短路时一直会拿这两者来比较，这次用SPFA来写，感觉和BFS相似，却也有不同之处，SPFA会用标记数组记录进入队列的点，而当点出队列时会取消标记（以后可能会再用到），进而松弛更新。</div>
<div>&nbsp;</div>
<div>
<div>
<pre class="prettyprint linenums">#include&lt;stdio.h&gt;<br />
#include&lt;math.h&gt;<br />
#include&lt;float.h&gt;  //DBL_MAX头文件<br />
#include&lt;queue&gt;<br />
using namespace std;

int a[][],b[][];<br />
double dis[][],sp[][];<br />
int t[][]={{,},{,},{-,},{,-}};<br />
int v0,r,c;<br />
struct Node{<br />
    int x,y;<br />
}node;<br />
double spfa(int x,int y)<br />
{<br />
    int i,j;<br />
    queue&lt;Node&gt; q;<br />
    for(i=;i&lt;=r;i++){<br />
        for(j=;j&lt;=c;j++){<br />
            dis[i][j]=DBL_MAX;<br />
        }<br />
    }<br />
    dis[x][y]=;<br />
    node.x=x;<br />
    node.y=y;<br />
    q.push(node);<br />
    b[x][y]=;<br />
    while(q.size()){<br />
        int fx=q.front().x;<br />
        int fy=q.front().y;<br />
        q.pop();<br />
        b[fx][fy]=;<br />
        for(i=;i&lt;;i++){<br />
            int tx=fx+t[i][];<br />
            int ty=fy+t[i][];<br />
            double t=sp[fx][fy];<br />
            if(tx&lt;||ty&lt;||tx&gt;r||ty&gt;c) continue;<br />
            if(dis[fx][fy]+t&lt;dis[tx][ty]){<br />
                dis[tx][ty]=dis[fx][fy]+t;<br />
                if(!b[tx][ty]){<br />
                    node.x=tx;<br />
                    node.y=ty;<br />
                    q.push(node);<br />
                    b[tx][ty]=;<br />
                }<br />
            }<br />
        }<br />
    }<br />
    return dis[r][c];<br />
}

int main()<br />
{<br />
    int i,j;<br />
    scanf("%d%d%d",&amp;v0,&amp;r,&amp;c);<br />
    for(i=;i&lt;=r;i++){<br />
        for(j=;j&lt;=c;j++){<br />
            scanf("%d",&amp;a[i][j]);<br />
            sp[i][j]=1.0/(v0*pow(2.0,a[][]-a[i][j]));  //提前记录<br />
        }<br />
    }<br />
    printf("%.2f\n",spfa(,));<br />
    return ;<br />
}</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49515eqz.html">【NLP】基于机器学习角度谈谈CRF（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql1nxk9.html">AIDL使用解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o40nxq.html">SharePoint 2013常用开发工具分享</a>
		</li>
						<li><a href="https://www.batexi.com/a/495jz10q.html">【译】Learn ES2015&mdash;&mdash;箭头函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8egg7e9.html">评分视图的封装 （星星 RatingView）</a>
		</li>
						<li><a href="https://www.batexi.com/a/39reryeq.html">【CodeForces 604B】F - 一般水的题1-More Cowbe</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1g442q.html">mybatis 中&num;&lbrace;&rcub;与&dollar;&lbrace;&rcub;的区别 &lpar;面试题&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yjdl3q.html">Apache HttpClient</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvpndzq.html">使用with语句来写一个稍微复杂sql语句，附加和子查询的性能对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pmg4n8.html">Openlayers 3 热力图</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp1x07q.html">webapi 使用Autofac 开发经历</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z5xln9.html">discuz7&period;2 faq&period;php 注入漏洞分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyymn19.html">26&period;C&plus;&plus;- 泛型编程之类模板&lpar;详解&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjx3ez9.html">正则表达式之javascript</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o177ypq.html">漏洞复现-vsftpd-v2&period;3&period;4</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjn7d09.html">Nginx的日志优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvez6ro9.html">Lua面向对象 --- 多态</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2xewj8.html">libhiredis&period;so&period;0&period;13&colon; cannot open shared object file&colon; No such file or director</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vnwl0q.html">GitLab Notification Emails</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2jkgj8.html">redis、mysql、和php原生array数组效率对比</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8odxvolq.html">如何使用RadioGroup和RadioButton实现FragmentTabHost导航效果？</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2x70zw9.html">【linux】记录一次系统被攻击的处理过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q15g4rz9.html">Eureka 集群</a>
			</li>
						<li><a href="https://www.batexi.com/a/qd56krx9.html">CSS3定时提示动画特效</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jeyvpl8.html">Python爬虫 &mdash;&mdash; 抓取美女图片（Scrapy篇）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy2e0yx9.html">Java并发知识概述</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxl0z3jq.html">BZOJ 3398 &lbrack;Usaco2009 Feb&rsqb;Bullcow 牡牛和牝牛：dp【前缀和优化】</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2x76k39.html">html5常用模板下载网站</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r4jwne8.html">html5--1&period;20 课程小结与若干点补充</a>
			</li>
						<li><a href="https://www.batexi.com/a/q15gdn49.html">IntelliJ IDEA 的 project 和 module 区别与关系</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
